// JavaScript Document

var pagefnames = Array();
//var traced = Array();
var pagefname = "";
var space = "&nbsp;&nbsp;&nbsp;&nbsp;";
var dspace = space+space;
var show_trace_coverage = false;

var defines = new Array();  // defines[symb].strings = array(strings);
							// defines[symb].matcher = Regexp;
var ndefines = 0;			// Number of defines (used to determine whether to show '#defines' table')

//var trace_filename = "trace.txt";

var hack_join = false;

var EqalReqIDWarning = "";
var rtable = "";
		
document.write('<div id="rqth" style="display:none"><h2>Requirements</h2></div>');
document.write('<div id="rqt">&nbsp;</div>');
document.write('<hr size="2" noshade>');
document.write('<div id="show_hide"><a href="javascript:reqShow();">Show Requirements</a></div>');
document.write('<hr size="2" noshade>');
if (document.addEventListener)
{
    document.addEventListener("DOMContentLoaded", placeHideShowLinkBtn, false);
}
else
{
    window.onload = placeHideShowLinkBtn;
}
function placeHideShowLinkBtn()
{
    var template_div = document.getElementById('template');
    if(template_div != null)
    {
        var hide_template_div = document.createElement('div');
        hide_template_div.id = "hide_template_div";
        document.body.insertBefore(hide_template_div, template);
        var text =  '<hr size="2" noshade>' +
                    '<div id="show_hide_tmp"><a href="javascript:hideShowTemplate();">Hide Template</a></div>' +
                    '<hr size="2" noshade>' +
                    '<div id="rtmph"><h2>Template</h2></div>';
        hide_template_div.innerHTML = text;
    }
}
/*
		
function getTrace() 
{
	var request=null;
	//     MSXML 2  
	try {
		request=new ActiveXObject('Msxml2.XMLHTTP');
	} catch (e){};
	//  ...   MSXML 1

	if(!request) try {
		request=new ActiveXObject('Microsoft.XMLHTTP');
	} catch (e){};

	//  ...   Mozilla
	if(!request) try {
		request=new XMLHttpRequest();
	} catch (e){};
	
	if(!request) try{
		var obj = document.getElementById("ifr");
		var obj_html = obj.document.getElementsByTagName("html");
		return obj_html[0].innerHTML;
	} catch (e){};

	//  
	request.open('GET', trace_filename, false);
	request.send(null);

	//  
	return request.responseText;
}*/

function getfname(s) //   .
{
	s = s.replace(/(^\s+|\s+$)/g,"");
	var c0;
	while( (c0 = s.charAt(0)) && (c0=="&" || c0=="#" || c0=="$"))
		s=s.substr(1); // skipping [&#$]+

	var i = s.indexOf(".");
	if(i<0)
		i=s.length;
	var res = s.substring(0,i);	
	if(res=="app")
	{
		j = s.indexOf(".",i+1);
		res=s.substring(i+1,j);
	}
	return res;
}

function getfnamep(s) //      app,   .
{
	s = s.replace(/(^\s+|\s+$)/g,"");
	var c0;
	while( (c0 = s.charAt(0)) && (c0=="&" || c0=="#" || c0=="$"))
		s=s.substr(1); // skipping [&#$]+

	var i = s.indexOf(".");
	var res = s.substring(0,i);	
	if(res=="app")
	{
		j = s.indexOf(".",i+1);
		res=s.substring(0,j);
	}
	return res;
}

function isApp(s) // checks id is app.
{
	s = s.replace(/(^\s+|\s+$)/g,"");
	var c0;
	while( (c0 = s.charAt(0)) && (c0=="&" || c0=="#" || c0=="$"))
		s=s.substr(1); // skipping [&#$]+

	var i = s.indexOf(".");
	var res = s.substring(0,i);	
	if(res=="app")
		return true;

	return false;
}

function showhide(id)
{
	var el = document.getElementById(id);
	if(!el)
		return;
	if(el.style.display == "none")
		el.style.display = "";
	else
		el.style.display = "none";
}

function showhideb(id,b)
{
	var el = document.getElementById(id);
	if(!el)
		return;
	if(b)
		el.style.display = "";
	else
		el.style.display = "none";
}

function showhideall()
{
	var allTempls = new Object();
	var b="none";
	allTempls = {0:"errdefs",
				 1:"errcode",
				 2:"pretmpl",
				 3:"posttmpl",
				 4:"reqs",
				 5:"qsts"	 	
				};
				 
	for(var i=0;i<6;i++)
		if(document.getElementById(allTempls[i]))
			if(document.getElementById(allTempls[i]).style.display=="none")
				b="";
				
	for(var i=0;i<6;i++)
		if(document.getElementById(allTempls[i]))
			document.getElementById(allTempls[i]).style.display=b;
}

function showrtable()
{
	var Borders = 
			'<Borders>\n<Border ss:Position="Bottom" ss:LineStyle="Continuous" ss:Weight="1"/>\n'+
			'<Border ss:Position="Left" ss:LineStyle="Continuous" ss:Weight="1"/>\n'+
			'<Border ss:Position="Right" ss:LineStyle="Continuous" ss:Weight="1"/>\n'+
			'<Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="1"/>\n</Borders>\n';

//	ww = window.open('about:blank', 'Table', 'location,width=800,height=600,top=0');
//	ww.document.write(rtable);
	var xml = rtable;
	xml = xml.replace(/<\s*table[^>]*>/i,'<Table ss:StyleID="s20">\n<Column ss:Width="97.5"/><Column ss:Width="290.25"/>\x0D\x0A');
	xml = xml.replace(/<\s*tr[^>]*>/gi,'<Row>\x0D\x0A');
//    xml = xml.replace(/<\s*td\s*align=right[^>]*>/gi,'<Cell ss:StyleID="s23"><Data ss:Type="String">');
	xml = xml.replace(/<\s*td\s*align=center[^>]*>/gi,'<Cell ss:StyleID="s23"><Data ss:Type="String">');
	xml = xml.replace(/<\s*td\s*align=left[^>]*>/gi,'<Cell ss:StyleID="s21"><Data ss:Type="String">');
	xml = xml.replace(/<\s*td\s*(\w+=\w+\%?)?\s*class=italic[^>]*>/gi,'<Cell ss:StyleID="s25"><Data ss:Type="String">');
	xml = xml.replace(/<\s*td\s*(\w+=\w+\%?)?\s*class=bold[^>]*>/gi,'<Cell ss:StyleID="s26"><Data ss:Type="String">');	
	xml = xml.replace(/<\s*td\s*colspan=2[^>]*>/gi,'<Cell ss:MergeAcross="1" ss:StyleID="s24"><Data ss:Type="String">');
	xml = xml.replace(/<\s*td\s*colspan=7[^>]*>/gi,'<Cell ss:MergeAcross="6" ss:StyleID="s24"><Data ss:Type="String">');	
	xml = xml.replace(/<\s*td[^>]*>/gi,'<Cell ss:StyleID="s22"><Data ss:Type="String">');
	xml = xml.replace(/<\/td>/gi,'</Data></Cell>\x0D\x0A');
	xml = xml.replace(/<\/tr>/gi,'</Row>\x0D\x0A');
	xml = xml.replace(/<br>/gi,'&#10;');
	xml = xml.replace(/&nbsp;/gi,'');
	xml = xml.replace(/<\s*div[^>]*>/gi,'&#10;');
	xml = xml.replace(/<\s*\/div[^>]*>/gi,'');
	xml = xml.replace(/<\s*span class=\'bigawrap\'\s*>/gi,' &#10 &#160 <span> ');
	xml = 
		'<?xml version="1.0"?>\n<?mso-application progid="Excel.Sheet"?>\n'+
		'<Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet">\n'+
		'<ExcelWorkbook xmlns="urn:schemas-microsoft-com:office:excel"/>\n'+
		'<Styles>\n'+
			'<Style ss:ID="s20">\n<Alignment ss:Vertical="Top" ss:WrapText="1"/>\n'+
			'<Font ss:FontName="Arial Cyr" x:CharSet="204" ss:Size="10"/>\n</Style>\n'+
		
			'<Style ss:ID="s21">\n<Alignment ss:Horizontal="Left" ss:Vertical="Top" ss:WrapText="1"/>\n'+
			Borders+
			'<Font ss:FontName="Verdana" x:CharSet="204" x:Family="Swiss" ss:Size="8"/>\n</Style>\n'+
			
			'<Style ss:ID="s22">\n<Alignment ss:Horizontal="Left" ss:Vertical="Top" ss:WrapText="1"/>\n'+
			Borders+
			'<Font ss:FontName="Arial Cyr" x:CharSet="204" ss:Size="10"/>\n</Style>\n'+
			
			'<Style ss:ID="s23">\n<Alignment ss:Horizontal="Center" ss:Vertical="Center" ss:WrapText="1"/>\n'+
			Borders+
			'<Font ss:FontName="Arial Cyr" x:CharSet="204" ss:Size="10"/>\n</Style>\n'+
			
			'<Style ss:ID="s24">\n<Alignment ss:Horizontal="Center" ss:Vertical="Top" ss:WrapText="1"/>\n'+
			Borders+
			'<Font ss:FontName="Verdana" x:CharSet="204" x:Family="Swiss" ss:Size="10" ss:Bold="1"/>\n</Style>\n'+

			'<Style ss:ID="s25">\n<Alignment ss:Horizontal="Left" ss:Vertical="Top" ss:WrapText="1"/>\n'+
			Borders+
			'<Font ss:FontName="Verdana" x:CharSet="204" x:Family="Swiss" ss:Size="8" ss:Italic="1"/>\n</Style>\n'+

			'<Style ss:ID="s26">\n<Alignment ss:Horizontal="Left" ss:Vertical="Top" ss:WrapText="1"/>\n'+
			Borders+
			'<Font ss:FontName="Verdana" x:CharSet="204" x:Family="Swiss" ss:Size="8" ss:Bold="1"/>\n</Style>\n'+

			'</Styles>\n'+
			
			'<Worksheet ss:Name="test">'
			
			+xml+
			'</Worksheet>\n</Workbook>';
			
    window.clipboardData.setData("Text", xml);
    window.alert("saved into clipboard");
}

function setTagBg(c, clrName)
{
	if(c.style)
	{
		c.style.backgroundColor = clrName;
		var incoll = c.getElementsByTagName("*");

		// recurse
		for(var j in incoll)
			setTagBg(incoll[j],clrName);
	}
}

// if (typeof Element != 'undefined' && Element.prototype && document.createRange)
if (typeof Element != 'undefined' && typeof Element != 'function' && Element.prototype && document.createRange)	 
{
   Element.prototype.__defineGetter__(
     'innerText',
     function () {
       var range = document.createRange();
       range.selectNodeContents(this);
       return range.toString();
     }
   );
   Element.prototype.__defineSetter__(
     'innerText',
     function (text) {
       var range = document.createRange();
       range.selectNodeContents(this);
       range.deleteContents();
       this.appendChild(document.createTextNode(text));
     }
   ); 
 }

/*function showCoverage()
{
	show_trace_coverage=true;
	reqHide();
	reqShow();
}

function hideCoverage()
{
	show_trace_coverage=false;
	reqHide();
	reqShow();
}*/

function reqHide()
{
	var coll = document.getElementsByTagName("*");
	var rqt = document.getElementById("rqt");
	var rqth = document.getElementById("rqth");	
	var showhide = document.getElementById("show_hide");

    showhide.innerHTML = '<a href="javascript:reqShow();">Show Requirements</a>';

	if (coll==null)
	  return;
	
	var res = "";
	for(i=0; i<coll.length; i++)
	{
		var c = coll[i];

		if(c.className=="req")
		{
			var clrName = "";
			setTagBg(c, "");
				
			var txt = c.innerHTML;
			if( txt.indexOf("{")==0 )
			{
				txt = txt.substring(txt.indexOf("}")+1);
				c.innerHTML = txt;
			}
		}

		if(c.className=="qst")
		{
			setTagBg(c, "");

			var txt = c.innerHTML;
			if( txt.indexOf("{")==0 )
			{
				txt = txt.substring(txt.indexOf("}")+1);
				c.innerHTML = txt;
			}
		}

	}
	rqt.innerHTML = "";
	rqth.style.display = "none";
}

// Strips the "app" and "ext" prefixes from the specified string
// and returns the result.
function stripPrefixes(str_id)
{
    var tstr = str_id;
    
    if (tstr.substr(0,4)=="app.")
    {
        tstr = tstr.substr(4);
        if (tstr.substr(0,4)=="ext.")
        {
            tstr = tstr.substr(4);
        }
    }
    else if (tstr.substr(0,4)=="ext.")
    {
        tstr = tstr.substr(4);
        if (tstr.substr(0,4)=="app.")
        {
            tstr = tstr.substr(4);
        }
    }
   
    return tstr;
}

function sortfunc(aa,bb)
{	
    var tmpa = stripPrefixes(aa); 
    var tmpb = stripPrefixes(bb);
    return tmpa.localeCompare(tmpb);
}

function remBadChars(str)
{
	str = str.replace(/\xA9/g,"(c)");
	str = str.replace(/\xAE/g,"(R)");
	str = str.replace(/\xD7/g,"x");
	str = str.replace(/\xFF/g,"");	
	return str;
}

function make_ptxt(txt, nls, nps) // nls - "new line" symbol; nps - new paragraf symbol
{
	txt = remBadChars(txt);

	txt = txt.replace(/<\s*li\s*(\s|[^>])*>/gi,"* ");
	
	txt = txt.replace(/<\s*\/?h[1234]\s*(\s|[^>])*>/gi,"\xFF");
	txt = txt.replace(/<\s*\/p\s*(\s|[^>])*>/gi,"\xFF");
	txt = txt.replace(/<\s*\/?br\/?\s*(\s|[^>])*>/gi,"\xFF");
	//txt = txt.replace(/<\s*\/td\s*(\s|[^>])*>/gi,"");
	txt = txt.replace(/<\s*\/dd\s*(\s|[^>])*>/gi,"\xFF");
	txt = txt.replace(/<\s*pre\s*(\s|[^>])*>/gi,"\xFA");
	txt = txt.replace(/<\s*\/pre\s*(\s|[^>])*>/gi,"\xFB");
	txt = txt.replace(/<[^>]+>/gi,"");

	while(txt.match(/\xFF\s*\xFF/))
		txt = txt.replace(/\xFF\s*\xFF/g,"\xFF");	
	
//	txt = txt.replace(/\n\s*\n/g,"\xFF"); // "\xFF" - such a sybmol that now can't be meet in the txt. It will mean <BR>
	txt = txt.replace(/&nbsp;/g," "); // "\xFE"
	txt = txt.replace(/\s+/g," "); // "\xFE"
	
	
	var ptxt="";
	var tmp = "";
	do
	{
		var newline = false;
		var q="";
		txt=txt.substr(txt.search(/\S/)); // first non-whitespace
		var txtlen = txt.length;
		var i=txt.search(/\xFF/);
		var ipre = txt.search(/\xFA/);
		if(ipre==0)
		{
			i = txt.search(/\xFB/)+1;
			if(i<0)
				i=txtlen-1;
			ptxt+=txt.substring(0,i);
			txt = txt.substr(i+1);
			continue;
		}
		else if( (ipre>0) && (ipre<i) )
		{
			i=ipre;
		}
		if(i>80 || i<0)
		{
			i=79;
			while(   (i>0 && i<txtlen && txt.charAt(i).match(/[\w\(\[;,{}]/) )
				  || ( (i+1<txtlen) && txt.charAt(i+1).match(/[;,{}\(\)]/) )  
				 ) i--;
			
			if(i==0) i=79; // 
		}
		else
		{
			newline = true;
		}
		q = txt.substring(0,i+1);
		//window.alert(q);
		tmp= "\xFF"+ q +( (q!="") && newline?"\xFF":"");
		ptxt +=" "+tmp;
		txt = txt.substr(i+1);
	}while(txt!="");

	ptxt = ptxt.replace(/^[\xFF\s]+/,""); // trim
	ptxt = ptxt.replace(/[\xFF\s]+$/,""); // trim
	ptxt = ptxt.replace(/\xFF\s*\xFF\s*\xFF\s*\xFF/g,"\xFF\xFF");
	ptxt = ptxt.replace(/\xFF\s*\xFF\s*\xFF/g,"\xFF\xFF");
	ptxt = ptxt.replace(/\xFF\s*\xFF/g,nps); // paragraph
	//window.alert(ptxt.replace(/\xFF/g,"|"));
	ptxt = ptxt.replace(/\xFF/g,nls); // new line
	ptxt = ptxt.replace(/\xFE/g,"&nbsp;");
	ptxt = ptxt.replace(/\xFA/g,"<pre>"); 
	ptxt = ptxt.replace(/\xFB/g,"</pre>"); 
	ptxt = ptxt.replace(/\xFC/g,"<br>&nbsp;&nbsp;&nbsp;&nbsp;"); 
	
//	window.alert(ptxt);
	return ptxt;
}

function showHead()
{
	var st_head = "";
	var tmp = document.body.innerHTML;
	var TMP = tmp.toUpperCase();
	var sp; var lp;
	if(tmp.indexOf("Linux Standard Base Core Specification")>=0)
	{// LSB 
		sp = TMP.indexOf("REFNAMEDIV");
		sp = TMP.indexOf(">",sp)+1;
		lp = TMP.indexOf("NAVFOOTER");
		lp = TMP.indexOf(">",lp)+1;
	}
	else
	{
		var hsp = TMP.indexOf("<"+"!--HEADER START--"+">");
		var hlp = TMP.indexOf("<"+"!--HEADER END--"+">",hsp);
		
		if(hsp<0)
		{
			hsp = TMP.indexOf("<CENTER");
			hlp = TMP.indexOf("<HR",hsp);
		}
		st_head = tmp.substring(hsp,hlp);
		st_head = st_head.replace(/<br>/gi,"\n");
		st_head = st_head.replace(/<[^>]+>/gi,"");
		st_head = st_head.replace(/(^\s*|\s*$)/gi,"");
		st_head = st_head.replace(/\n\s*\n/gi,"\n");
		st_head = st_head.replace(/\n/gi,"<br>");
		st_head = remBadChars(st_head);
		
		sp = hlp;
		lp = TMP.indexOf("THE FOLLOWING SECTIONS ARE INFORMATIVE");
		if(lp<0)
		{
			lp = TMP.indexOf("APPLICATION USAGE");
	}
	}
	tmp = tmp.substring(sp,lp);
	
	tmp = tmp.replace(/<H2>Name<\/H2>/i,"<H2>NAME</H2>");
	tmp = tmp.replace(/<H2>Synopsis<\/H2>/i,"<H2>SYNOPSIS</H2>");
	tmp = tmp.replace(/<H2>Description<\/H2>/i,"<H2>DESCRIPTION</H2>");
	tmp = tmp.replace(/<H2>Return Value<\/H2>/i,"<H2>RETURN VALUE</H2>");
	tmp = tmp.replace(/<H2>Errors<\/H2>/i,"<H2>ERRORS</H2>");
/*	tmp = tmp.replace(/<\s*\/?h[1234](\s[^>])*>/gi,"\n\n");
	tmp = tmp.replace(/<\s*\/?p(\s[^>])*>/gi,"\n\n");
	tmp = tmp.replace(/<[^>]+>/gi,""); /*replaced to make_ptxt*/
	//tmp = remBadChars(tmp);
	//window.alert(tmp);
	tmp = tmp.substr(tmp.search(/name<\/h/i)); // skipping all before Name (for LSB)
				
	var result = "Linux Standard Base Core Specification 3.1<BR>Copyright (c) 2004, 2005 Free Standards Group<BR>";
	if(st_head)
	{
		result += "<BR>&nbsp;&nbsp;&nbsp;&nbsp;refers<BR><BR>"+st_head+"<BR>";
	}
	result += "<BR>";
	result += make_ptxt(tmp,"<BR>","<BR><BR>");
	result = "<code>\n"+result+"</code>";

	var testArea = document.getElementById("rqt");
	var showhide = document.getElementById("show_hide"); 
	testArea.innerHTML = result;
	showhide.innerHTML = '<a href="javascript:hideHead();">Hide head</a>';
}
function hideHead()
{	
	var testArea = document.getElementById("rqt");
	var showhide = document.getElementById("show_hide");

	testArea.innerHTML = "";
	
	showhide.innerHTML = '<a href="javascript:reqShow();">Show Requirements</a><br><a href="javascript:showHead();">Show head</a>';
}

function formatParents(allReqs, id, space)
{
	var res = "";
	var parentId = id;
	while(parentId)
	{
		res = space+" * "+make_ptxt(allReqs[parentId].origHTML,"<BR>"+space+" * ","<BR>"+space+" * ")
			+ (res?"<BR>"+space+" *<BR>":"") + res;
		parentId = allReqs[parentId].parentId;
	//	window.alert(res.replace(/&nbsp;/gi,""));
	}
	return space+"/*<BR>"+res+"<BR>"+space+" */<BR>";
}

function formatParentsTxt(allReqs, id)
{
	var res = "";
	var parentId = id;
	while(parentId)
	{
		res = make_ptxt(allReqs[parentId].origHTML,"<BR>","<BR>")
			+ (res?"<BR><BR>":"") + res;
		parentId = allReqs[parentId].parentId;
	//	window.alert(res.replace(/&nbsp;/gi,""));
	}
	return res;
}

function p_req_cov(cov)
{
	var res="<b><div style='padding-left:40px'>";
	for(var i in cov)
		res+="<li>"+cov[i]+"</li>\n";
	
	res+="</div></b>\n";
	return res;
}

function pt_req_cov(cov)
{
	if(!cov) return "";
	var res = "";

	var l_cov = cov.length;
	for(var i=0;i<l_cov;i++)
		res += "<tr><td align=right><b>."+cov[i]+"</b></td><td>&nbsp;</td><td align=center>&nbsp;</td><td align=center>&nbsp;</td><td align=center>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>"
	return res;
}

function parseForErrCodes(txt)
{
	/* err requirement may look as:
		{req.id}lalala 
		{req.id}[ERRNAME] [XSI] lalala
		{req.id}[ERRNAME] or [ERRNAME2] [XSI] lalala
		{req.id}shall not [EINTR].
	/**/
	var errCodes = new Array;

	if(!txt)
		return errCodes;
	
	var errname = "\\[(E\\w+|\\w+_ERROR|HOST_\\w+|NO_\\w+|\\w+_AGAIN)\\]"; // [EXXXX] | [XXXX_ERROR]
	var expr = errname+"(\\s*or\\s*"+errname+")?"; // [ERRNAME] or [ERRNAME]
	var regexp = new RegExp(expr,"");
	var match= txt.match(regexp); 
	if(match)
	{
		if(match[1])
			errCodes.push(match[1]);
		if(match[3])
			errCodes.push(match[3]);
	} else {
		var errname = "\\[(\\w+)\\]"; // [XXXX]
		var regexp = new RegExp(errname,"");
		var match= txt.match(regexp);
		if(match)
		{
			if(match[1])
				errCodes.push(match[1]);
		}
	}
	return errCodes;
}

function expand_subst(id) {
	var ids = new Array(id);
	do {
		var subst_done = true;
		var ids_len = ids.length;
		var new_ids = new Array();
		for(var thisid=0; thisid<ids_len; thisid++ ) {
			var id = ""+ids[thisid];
			var replaced = false;
			for ( var symb in defines ) {
				if ( id.match(defines[symb].matcher) ) {
					replaced = true;
					subst_done = false;
					for (var str_i in defines[symb].strings) {
						var str = defines[symb].strings[str_i];
						var id_tmp = id;
						id_tmp = id_tmp.replace(defines[symb].matcher, str);
						new_ids.push(id_tmp);
					}
				}
			}
			if (!replaced) {
				new_ids.push(id);
			}
		}
		ids = new_ids;
	//	window.alert(ids);
	}while (!subst_done);
	return ids;
}

function filter_general(general, fname)
{
	var res = "";
	var g_spl = general.split(";");
	for(var i in g_spl)
	{
		var tmp = g_spl[i];
		var tmp_spl = tmp.split("/");
		var tmp_spl_len = tmp_spl.length;

		var exp = expand_subst(tmp_spl[0]);
		for (var k in exp ) {
			var id = exp[k];
			if(getfname(id) == fname)
				res += (res?";":"")+id;
		}

		for(var j=1;j<tmp_spl_len;j++)
		{
			var exp = expand_subst(tmp_spl[j]);
			for (var k in exp ) {
				var id = exp[k];
				if(getfname(id) == fname)
					res += "/"+id;
			}
		}
	}
	return res;
}

function format_confvar(varname, comment, def)
{
	comment = comment.replace(/(^\s+|\s+$)/,"");
	comment = comment.replace(/[\x0A\x0D]+/gi,"\x0A                      ");
	var res = "";
	res += "option "+varname+" {\n";
    res += "    type            \"bool\"\n";
    res += "    kind            \"var\"\n";
    res += "    destination     \"\"\n";
    res += "    description     /@"+comment+"@/\n";
    res += "    values {\n";
    res += "    "+(def==0?"default:":"        ")+"        0  /@False@/\n";
    res += "    "+(def==1?"default:":"        ")+"        1  /@True@/\n";
    res += "    }\n";
    res += "}\n\n";
    return res;
}

function reqShow()
{
	var rqt = document.getElementById("rqt");
	var rqth = document.getElementById("rqth");	

	//
	var allReqs = new Array();
	
	// 
	var errIdents = new Array();
	var errBlocks = new Array();
	
	var globIDsCollision = false;

	var showhide = document.getElementById("show_hide");
	showhide.innerHTML = '<a href="javascript:reqHide();">Hide Requirements</a><br>';

	// first walk start. Gathering reqs.
	var coll = document.getElementsByTagName("*"); if (!coll) return;
	var clen = coll.length;
	for (i=0; i<clen; i++)
	{ 
		var found_in_trace = false;
		if(i==clen-1) clen = coll.length; // coll.length changes dynamicaly
		
		var c = coll[i];

		if(c.className=="define") {
			var symb = ""+c.name;
			var strings = ""+c.title;
            
			ndefines++;
			defines[symb] = new Object();
			defines[symb].matcher = new RegExp;
			defines[symb].matcher.compile(symb+"\\b","");
			defines[symb].strings = new Array();
			var strings_spl = strings.split(";");
			var strings_spl_len = strings_spl.length;
			for (var j=0; j<strings_spl_len; j++) {
				strings_spl[j] = strings_spl[j].replace(/(^\s+|\s+$)/g,"");
				defines[symb].strings.push(strings_spl[j]);
			}
		}
		
		if(c.className=="req")
		{
			var title = ""+c.title;
			var ids_spl = (""+c.id).split(";");
			
			var ids = new Array();
			
			// Checking id-coverage. Syntax: "id.01;id.02;id.03;[cov1/cov2/cov3]"
			var ids_spl_len = ids_spl.length;
			for(var j=0; j<ids_spl_len; j++ )
			{
				var id = ""+ids_spl[j];
				
				var id_cov="";
				if( id.match(/^\s*\[.*\]\s*$/i) ) // req-cov exists
				{
					var id_cov = id.replace(/(^\s*\[\s*)|(\s*\]\s*$)/gi,""); // removing [ and ]
					id_cov_spl = id_cov.split("/"); 
					
					var new_ids = new Array();
					for(var k in ids)
					{
						for(var rk in id_cov_spl)
							new_ids.push(ids[k]+"."+id_cov_spl[rk]);
					}
					ids = new_ids;
				}
				else // not rec-cov
				{
					ids.push(id);
				}
			}
			
			// subst
			var new_ids = new Array();
			for(var thisid in ids ) {
				var id = ""+ids[thisid];
				var expanded_id = expand_subst(id)
				new_ids = new_ids.concat(expanded_id);
			}
			ids = new_ids;
			
			// c.title processing
			// GENERAL
			var general = "";
			if( c.title && c.title.match(/^GENERAL\s*:/) ) {
				general = c.title.substr( c.title.indexOf(":")+1 ); 
			}
            
            var lastCh = c.lastChild;
            var altFormText = "";
            if (lastCh.className=="form")
            {
                altFormText = getElementText(lastCh);
                if(altFormText != null)
                    altFormText = altFormText.replace(/[\n\r]+/g, " ");
            }
            else
            {
                altFormText = getElementText(c);
            }
			
			var ids_len = ids.length;
			for(var thisid=0; thisid<ids_len; thisid++ ) // ids
			{
				//
				var id = ""+ids[thisid];
				var tmp_id=id;
				var IDsCollision = false;
				
				// check if this ID was found in trace
				/*if( undefined!=traced[id] && show_trace_coverage )
					found_in_trace = true;*/
				
				tmp_id = id;
				var doubled = false;
				var c0;
				while( (c0 = tmp_id.charAt(0)) && (c0=="!" || c0=="?" || c0=="&" || c0=="$" )) {
					if(c0 == "&") doubled = true;
					tmp_id = tmp_id.substr(1);
				}
				
				if(allReqs[tmp_id]) // checking collisions
				{
					if(!doubled)
					{
						while(allReqs[id])
							id = "+"+id;
						IDsCollision = true; // for this req
						globIDsCollision = true; // global header alert
						allReqs[tmp_id].IDsCollision = true;
					}
				}
				
				if(id=="") // checking if empty id
				{
					IDsCollision = true; // for this req
					globIDsCollision = true; // global header alert
					id="Empty ID!";
					while(allReqs[id])
						id = id+"!";
				}
				
				allReqs[id] 		= new Object(); // creating new REQ
				allReqs[id].id		= id;
				allReqs[id].pos		= thisid;
				allReqs[id].c		= c;
				//allReqs[id].txt		= c.innerText;
				allReqs[id].origHTML= c.innerHTML;
				allReqs[id].title	= c.title;
				allReqs[id].IDsCollision	=	IDsCollision;
                
                allReqs[id].txt = altFormText;
				
				if (general) {
					allReqs[id].general = filter_general(general, getfname(id));
				}
				
			} // end of ids
			
			// highlighting html
			tmphtml = ""+c.innerHTML;
			if(tmphtml.substring(0,3).toUpperCase()=="{<A")
				tmphtml = tmphtml.substr(tmphtml.toUpperCase().indexOf("</A>}")+5);
			tmphtml = "{<a name='anch." + c.id + 
                "' href='#topanch." + c.id + 
                "' title='" + (altFormText!= null?altFormText.replace(/[\'\"]/g, ""):"") +
                "'><b>" + c.id + "</b></a>" +  
				(c.title == id || c.title == "" ? "" : " <font color=blue>| " + 
                 c.title+"</font>")+
				"} "+tmphtml;
                
			try // adding {req.id}
            {
                c.innerHTML = tmphtml
            }
            catch(e){}; 
            
			if(c.title=="") c.title = id; // modifying title.
			if(!found_in_trace)
				setTagBg(c, "#FFFF99"); // highlighting yellow
			else
				setTagBg(c, "lightgreen"); // highlighting
			// end of highlighting
		} // end of if classname = req
		
		else if( (c.className=="struct") || (c.className=="qst"))
		{
			// highlighting html
			tmphtml = ""+c.innerHTML;
			if(tmphtml.substring(0,3).toUpperCase()=="{<A")
				tmphtml = tmphtml.substr(tmphtml.toUpperCase().indexOf("</A>}")+5);
			tmphtml = "{<a name='anch."+c.id+"' href='#topanch."+c.id+"' style='color:#000000'><b>"+c.id+"</b></a>"+ 
				(c.title==id||c.title==""?"":" <font color=blue>| "+c.title+"</font>")+
				"} "+tmphtml;
			try{c.innerHTML = tmphtml}catch(e){}; // adding {req.id}
			if(c.title=="") c.title = id; // modifying title.
			if(!found_in_trace)
				setTagBg(c, "#DDDDDD"); // highlighting 
			else
				setTagBg(c, "lightgreen"); // highlighting
			// end of highlighting
		} // end of if classname = struct/qst
	} // end of first walk
	/* Now we have allReqs[elem_id] - array of reqs. */
	
	//window.alert("first walk done");
    
    //alert ("IDs="+expand_subst("ANOTHER_DEF.05.45"));
    //alert ("IDs="+expand_subst("xvfz.06.88.03"));
	
	// Second walk. Making children - parents reference.
	for(var id in allReqs)
	{
		var probParentId = id.substring(0, id.lastIndexOf("."));
		
		//<>
/*		if (probParentId == "atk_image_get_image_size.02")
		{
			alert("ID="+id);
		}*/
		//<>

		if(allReqs[probParentId])
		{
			allReqs[id].parentId = probParentId;
			if(!allReqs[probParentId].children)
				allReqs[probParentId].children = new Array(); // array of id's
			allReqs[probParentId].children.push(id);
		}
	}
	/* Now all elements of allReqs[] have .parentId and .children[child_id] */

	// Third walk. Errors recognition. 
	for(var id in allReqs)
	{
		var req =  allReqs[id];
		var match = "";
		if( 
			match = req.title.match(/^\s*(SHALL3?|MAY3?|NEVER|UNCHECKABLE)\s*:\s*(.*)$/) 
		)// if is err
		{ 
			//window.alert(id+" is err");
			req.isErr = true; // root err block

			var errKind = match[1]; // SHALL, MAY, or something
			var errIdentLine = match[2]; // POSIX_FUNC_NAME
			
			var t_spl = errIdentLine.split(";");
			// subst
			var new_t_spl = new Array();
			for(var jj in t_spl ) {
				var t = ""+t_spl[jj];
				var expanded_t = expand_subst(t)
				new_t_spl = new_t_spl.concat(expanded_t);
			}
			t_spl = new_t_spl;

			if(req.pos>=t_spl.length)
				window.alert("("+id+") "+errKind+": Identifier number "+req.pos+" not found!");
			var errIdent = t_spl[req.pos];

			//window.alert(errKind+"  "+errIdent);
			
			errBlocks[id] = new Object(); // creating errors block
			errBlocks[id].rootId	= id;
			errBlocks[id].kind		= errKind;
			errBlocks[id].ident = errIdent;
			
			if(!errIdents[errIdent])
			{	// creating Ident
				errIdents[errIdent] = new Object();
				errIdents[errIdent].errBlockIds = new Array();
			}
			errIdents[errIdent].errBlockIds.push(id); // adding to Idents
			
			var all_children = new Array();
			var arr = new Array();
			arr.push(id);
			//arr = arr.concat(req.children);
			while(arr.length)  // width-walkthrow children tree
			{
				var arr2 = new Array;
				
				var arr_len = arr.length;
				for(var jj=0; jj<arr_len; jj++) 
				{
					var id1 = arr[jj];
					//window.alert(id1);
					var elem_id1 = allReqs[id1];
					allReqs[id1].isErr = true;
					
					// obtain error code [ENAME]
					var errCodes = parseForErrCodes(elem_id1.origHTML);
					//var errCodes = parseForErrCodes(elem_id1.txt);
					
					if(!errCodes.length) // if req is error-req
					{
						if(elem_id1.parentId)
						{
							errCodes = allReqs[elem_id1.parentId].errCodes;
						}
					}
					
					allReqs[id1].errCodes = errCodes;
					
					if(elem_id1.children)
						arr2 = arr2.concat(elem_id1.children);
				}
				//window.alert("test");
				all_children = all_children.concat(arr);
				arr = arr2;
			} // end of while arr (width walkthrow)
			
			// now all_children looks like: id.02.01; id.02.02; then(II) id.02.01.01; id.02.01.02; id.02.02.01; then(III) id.02.01.02.01
			errBlocks[id].allChildren = all_children;
			
		} // end of isErr
	} // end of third walk
	/*  Now all elements of allReqs that are errors have .isErr and .errCodes attributes
		Also we have the errBlocks array.
	*/
	
	// -- fourth walk. templates -----
	var resCodeTemplatePre = "";
	var resCodeTemplatePost = "";
	var res = "";
    var res_xml = "";
	var resq = "";
		rtable = ""; // global

	// sorting
	reqSort = new Array();
	for(var id in allReqs)
		reqSort.push(id);
	reqSort = reqSort.sort(sortfunc);
	
	// splitting by funcname
	reqSplit = new Array();
	for(var id in allReqs)
	{
		var fname = getfname(id);
		if(!reqSplit[fname])
			reqSplit[fname] = new Array();
		
		reqSplit[fname].push(id);
	}	
	var reqSplitSort = new Array();
	for(var fname in reqSplit)
		reqSplitSort.push(fname);
	reqSplitSort = reqSplitSort.sort();

	// ----------------------------------------------------
	// res & res_xml generation. (Requirements table)
	for(var i in reqSort)
	{
		var id = reqSort[i];
		var elem = allReqs[id];
        var etxt = elem.txt;

		res += "<TR><TD>"+"</TD><TD>{<a name='topanch."+elem.id+
		    "' href='#anch."+elem.c.id+"'"+(elem.IDsCollision?" style='color:red'":"")+"><b>"+
		    elem.id+
		    "</b></a>}"+
		    (elem.title && (elem.title!=elem.id)?"<br>\n"+elem.title.replace(/;/gi,"; "):"")+
		    "</TD>\n<TD>"+/*html*/elem.txt+"</TD></TR>\n";
        
        if ((elem.id.charAt(0) != '&') && (!elem.children)) // exclude references and parent REQs
        {
            etxt = etxt.replace(/&/g, "&amp;amp;");
            etxt = etxt.replace(/</g, "&amp;lt;");
            etxt = etxt.replace(/>/g, "&amp;gt;");
            etxt = etxt.replace(/\'/g, "&amp;apos;");
            etxt = etxt.replace(/\"/g, "&amp;quot;");
            res_xml += "&lt;req id=\"" + elem.id + "\"&gt;<br>"+ space + etxt + "<br>&lt;/req&gt;<br>";
        }
	}
	// end of res generation. (Requirements table)
	// ----------------------------------------------------
	
	// ----------------------------------------------------
	// resCodeTemplatePre/Post generation. (Template Pre/Post)
/*	for(var i in reqSplitSort)
	{
		var b_pre = false;
		var b_post = false;

		var fname = reqSplitSort[i];
		
		var ids = reqSplit[fname];
		for(var j in ids)
		{
			id = ids[j];
			var elem = allReqs[id];

			if(elem.isErr) continue;
			
			if(!elem.children)
			{
				var resCodeTemplate = "";
				var stub = "TODO_REQ()";
				
				if(elem.general)
				{
					stub = 'GENERAL_REQ("'+elem.general+'")';
				}
				
				resCodeTemplate += formatParents(allReqs, id, dspace); 
				// REQ("id",..,..);
				if(hack_join)
					resCodeTemplate += dspace+"REQ(\""+elem.c.id+"\", \"\", TODO_REQ());<br><br>";
				else
					resCodeTemplate += dspace+"REQ(\""+id+"\", \"\", "+stub+");<br><br>";
				
				if(isApp(elem.id))
				{
					if(!b_pre)
						resCodeTemplatePre += "<HR>\n"+space+"<b>"+fname+"()</b><HR>";

					resCodeTemplatePre += resCodeTemplate;
					b_pre = true;
				}else{
					if(!b_post)
						resCodeTemplatePost += "<HR>\n"+space+"<b>"+fname+"()</b><HR>";

					resCodeTemplatePost += resCodeTemplate;
					b_post = true;
				}
			}
		}
	}*/
	// end of resCodeTemplatePre/Post generation. (Template Pre/Post)
	// ----------------------------------------------------
	
	
	// ----------------------------------------------------
	// rtable generation
	rtable += "<TABLE border=1>";
	for(var i in reqSplitSort)
	{
		var fname = reqSplitSort[i];
	
		rtable += "<TR><TD colspan=7 align=center><b>"+fname+"()</b></TD></TR>";

		var ids = reqSplit[fname];
		ids = ids.sort(sortfunc);
		// not errors
		for(var j in ids)
		{
			var id = ids[j];
			var elem = allReqs[id];
			//window.alert(fname+" "+id);
			
			if(elem.isErr) continue; // not errors
			
			if(!elem.children)
			{
				rtable += "<TR><TD width=1% class=bold><b><nobr>"+elem.id+"</nobr></b></TD>"
					+ "<TD>"+formatParentsTxt(allReqs,elem.id)+"</TD>" // + 5 empty cells
					+"<TD align=center>&nbsp;</TD><TD align=center>&nbsp;</TD><TD align=center>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>"
					+"</TR>";
			}
			//window.alert(rtable);
		}
		
		// rtable errors section.
		rtable += "<TR><TD colspan=2 align=middle><b>Errors</b></TD>"
			+"<TD align=center>&nbsp;</TD><TD align=center>&nbsp;</TD><TD align=center>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>"
			+"</TR>";
			
		// errors
		for(var j in ids)
		{
			var id = ids[j];
			var elem = allReqs[id];

			if(!elem.isErr) continue; // errors
			
			if(elem.children)
			{
				rtable += "<TR><TD width=1% class=italic><i><nobr>"+elem.id+"</nobr></i></TD>"
					+ "<TD class=italic><i>"+make_ptxt(allReqs[id].origHTML,"<BR>","<BR>")+"</i></TD>" // + 5 empty cells
					+"<TD align=center>&nbsp;</TD><TD align=center>&nbsp;</TD><TD align=center>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>"
					+"</TR>";
			}else{
				rtable += "<TR><TD width=1% class=bold><b><nobr>"+elem.id+"</nobr></b></TD>"
					+ "<TD>"+make_ptxt(allReqs[id].origHTML,"<BR>","<BR>")+"</TD>" // + 5 empty cells
					+"<TD align=center>&nbsp;</TD><TD align=center>&nbsp;</TD><TD align=center>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>"
					+"</TR>";
			}
		}
	}
	rtable += "</TABLE>";
//	if(window.clipboardData)
//		rtable += "<a href='#' onclick='showrtable()'>To clipboard</a>";
	// end of rtable generation
	// ----------------------------------------------------

		
	// resCodeErrDefs generation. (configuration constants)
	var resCodeErrDefs = "";
	var resCodeErrDefsScopes = new Array(); // scope block
	var resCodeErrDefsDefs = new Array(); // other
	for(var ident in errIdents)
	{
		var errBlockIds = errIdents[ident].errBlockIds;
		for(var i in errBlockIds)
		{
			var id = errBlockIds[i];
			var block = errBlocks[id];
			var fname = getfname(id);
			//window.alert(id+" "+fname+" "+block);
			
			if(!resCodeErrDefsScopes[fname])
				resCodeErrDefsScopes[fname] = new Array();
			
			var varname = block.ident+"_HAS_EXTRA_ERROR_CODES";
			var comment =
				"If this constant is set to 1, then current implementation of "+fname+"() \n"+
				"may support additional errors not included in the list described in the\n"+
				"IEEE Std 1003.1, 2004 Edition.\n";
			resCodeErrDefsScopes[fname][varname] = 1;
			if(!resCodeErrDefsDefs[fname])
				resCodeErrDefsDefs[fname] = new Array();
			resCodeErrDefsDefs[fname][varname] = format_confvar(varname, comment, 0);
			
			for(var j in block.allChildren)
			{
				var child = allReqs[block.allChildren[j]];
				
				if(!child.errCodes) 
					continue;
				
				for(var ch_ec in child.errCodes)
				{
					var errcode = child.errCodes[ch_ec];
					if( (block.kind=="MAY") || (block.kind=="MAY3") ) 
					{
						varname = block.ident+"_FAILS_WITH_"+errcode;
						comment =
							"If this constant is set to 1, the function "+fname+"() ensures\n"+
							"that the error "+errcode+" will be found and correctly handled.\n";
						resCodeErrDefsScopes[fname][varname] = 1;
						resCodeErrDefsDefs[fname][varname] = format_confvar(varname, comment, 0);
						
						varname = block.ident+"_HAS_EXTRA_CONDITION_ON_"+errcode;
						comment =
							"If this constant is set to 1, the current implementation of "+fname+"() \n"+
							"may generate error code of "+errcode+" under circumstances other than those \n"+
							"described in the IEEE Std 1003.1, 2004 Edition.\n";
						resCodeErrDefsScopes[fname][varname] = 1;
						resCodeErrDefsDefs[fname][varname] = format_confvar(varname, comment, 0);
					} 
					else if( (block.kind=="SHALL") || (block.kind=="SHALL3") )
					{
						varname = block.ident+"_HAS_EXTRA_CONDITION_ON_"+errcode;
						comment =
							"If this constant is set to 1, the current implementation of "+fname+"() \n"+
							"may generate error code of "+errcode+" under circumstances other than those \n"+
							"described in the IEEE Std 1003.1, 2004 Edition.\n";
						resCodeErrDefsScopes[fname][varname] = 1;
						resCodeErrDefsDefs[fname][varname] = format_confvar(varname, comment, 0);
					}
				}
			}// end of block children
			
		}// end of errBlocks
	}// end of Idents
	for(var fname in resCodeErrDefsScopes)
	{
		resCodeErrDefsScope = "scope  "+fname+"_spec                                     { ";
		var scni = 0;
		for(var scn in resCodeErrDefsScopes[fname])
		{
			if(scni != 0)
				resCodeErrDefsScope += ",\n                                                   ";
			resCodeErrDefsScope += scn; //resCodeErrDefsScopes[fname][scn]
			scni++;
		}
		resCodeErrDefsScope += " }\n\n";
	
		if(!resCodeErrDefs)
			resCodeErrDefs = "";
		
		if(resCodeErrDefsScope)
			resCodeErrDefs += resCodeErrDefsScope;
		
		if(resCodeErrDefsDefs[fname])
		{
			for(var varname in resCodeErrDefsDefs[fname])
			{
				resCodeErrDefs += resCodeErrDefsDefs[fname][varname];
			}
		}
	}
	// end of resCodeErrDefs generation. (olver.tree block)	
	
				
	// resCodeErr generation. (Template Errors)
	var resCodeErr = "";
	for(var ident in errIdents)
	{
		// preparing `shall`
		var shall = new Array(); // shall[ERRNAME] = array(req.id)
		var errBlockIds = errIdents[ident].errBlockIds;
		for(var i in errBlockIds)
		{
			var block = errBlocks[errBlockIds[i]];
			if( (block.kind != "SHALL") && (block.kind != "SHALL3") )
				continue;
			
			for(var j in block.allChildren)
			{
				var child = allReqs[block.allChildren[j]];
				if(child.children)
					continue;
				
				for(var i in child.errCodes)
				{
					var code = child.errCodes[i];
					if(!shall[code])
						shall[code] = new Array();
					
					shall[code].push(child.id);
				}
			}
		}
		
		// generating templates
		resCodeErr += dspace+"ERROR_BEGIN("+ident+", \"!\", /* is_error */, /* *errno */)<BR><BR>\n";
		
		var prev_head = "";
		for(var code in shall)
		{
			var reqs = shall[code];
			
			var head1="";
			for(var i in reqs)
			{
				head1 += formatParents(allReqs, reqs[i], dspace+space);
			}
			if(head1 != prev_head)
			{
				resCodeErr += head1;
				prev_head = head1;
			}
			
			if(reqs.length>1)
			{
				resCodeErr+=
					dspace + space + "ERROR_SHALL("+
					 block.ident+", "+code+", \""+reqs.join(";")+"\",\n<BR>";
				for(var i in reqs)
				{
					resCodeErr += dspace+dspace+dspace+(i>0?"|| ":"&nbsp;&nbsp; ")+"TODO_ERR("+code+") /*"+reqs[i]+"*/\n<BR>";
				}
				resCodeErr += dspace+dspace+dspace+")<BR><BR>\n";
			}else{
				resCodeErr+=
					dspace + space + "ERROR_SHALL("+
					 block.ident+", "+code+", \""+reqs.join(";")+"\", TODO_ERR("+code+") )<BR><BR>\n";
			}
		}
		
		for(var i in errBlockIds)
		{
			var block = errBlocks[errBlockIds[i]];

			for(var j in block.allChildren)
			{
				var child = allReqs[block.allChildren[j]];
				if(child.children)
					continue;
				
				/*
				 * Quotation from the standard 
				 */ 
				if(block.kind.match(/(MAY3?|NEVER)/))
				{
					resCodeErr += formatParents(allReqs, child.id, dspace+space);
				}
				// todo: (1) 2 or more errors in child.errCodes;
				// todo: (2) equal defines in different section: MAY and SHALL on the same ERRNAME
				
				if(block.kind=="MAY") 
				{
					for(var i in child.errCodes)
					{
						var code = child.errCodes[i];
						resCodeErr+=
							dspace + space + "ERROR_MAY("+
							block.ident+", "+code+", \""+child.id+"\", TODO_ERR("+code+")"+
							")<BR><BR>\n";
					}
				} 
				else if(block.kind=="MAY3") 
				{
					for(var i in child.errCodes)
					{
						var code = child.errCodes[i];
						resCodeErr+=
							dspace + space + "ERROR_MAY3("+
							block.ident+", "+code+", \""+child.id+"\", TODO_ERR("+code+")"+
							")<BR><BR>\n";
					}
				} 
				else if(block.kind=="NEVER") 
				{
					for(var i in child.errCodes)
					{
						var code = child.errCodes[i];
						resCodeErr+=
							dspace + space + "ERROR_NEVER("+
							 block.ident+", "+code+", \""+child.id+"\""+
							")<BR><BR>\n";
					}
				}
				else if(block.kind!="SHALL")
					window.alert("Unknown error kind: "+block.kind);
			}//
		}// end of errBlocks
		
		resCodeErr += dspace+"ERROR_END()<BR><BR>\n";
		
	}// end of Idents
	// end of resCodeErr generation. (Template Errors)
	
	// #defines 
	var defines_text = '<table border=0>';
	for( var symb in  defines) {
		defines_text += '<tr><td><b>'+symb+'</b></td>';
		defines_text += '<td> : '+defines[symb].strings.join(', ')+';</td>';
		defines_text += '</tr>'
	}
	defines_text += '</table>'
	//end of #defines

	// General output
	rqt.innerHTML = 
		(globIDsCollision?"<H3 style='color:red'>Warning! IDs collision!</H3>":"")
		//+(resCodeErrDefs?"<h4>olver.tree <a href='javascript:showhide(\"errdefs\")'>&gt;&gt;</a></h4><div id='errdefs' style='display:none'><pre>"+resCodeErrDefs+"</pre></div>":"")
		//+(resCodeErr?"<h4>Template Errors <a href='javascript:showhide(\"errcode\")'>&gt;&gt;</a></h4><div id='errcode' style='display:none'><code>"+resCodeErr+"</code></div>":"")
		//+(resCodeTemplatePre?"<h4>Template Pre <a href='javascript:showhide(\"pretmpl\")'>&gt;&gt;</a></h4><div id='pretmpl' style='display:none'><code>"+resCodeTemplatePre+"</code></div>":"")
		//+(resCodeTemplatePost?"<h4>Template Post <a href='javascript:showhide(\"posttmpl\")'>&gt;&gt;</a></h4><div id='posttmpl' style='display:none'><code>"+resCodeTemplatePost+"</code></div>":"")
		+(res?"<h4>Table <a href='javascript:showhide(\"reqs\")'>&gt;&gt;</a></h4><div id='reqs' style='display:none'><table border=1 cellspacing=0 cellpadding=3>"+res+"</table></div>":"")
        +(res_xml?"<h4>REQ Catalogue (XML)<a href='javascript:showhide(\"reqs_xml\")'>&gt;&gt;</a></h4><div id='reqs_xml' style='display:none'><font color=green>&lt;?xml version=\"1.0\"?&gt;<br>&lt;requirements&gt;<br>"
            + res_xml + 
            "&lt;/requirements&gt;<br><br></font></div>":"")
		//+(resq?"<h4>Questions: <a href='javascript:showhide(\"qsts\")'>&gt;&gt;</a></h4><div id='qsts' style='display:none'><table border=1 cellspacing=0 cellpadding=3>"+resq+"</table></div>":"")
		//+(rtable?"<h4>Table: <a href='javascript:showhide(\"rtable\")'>&gt;&gt;</a></h4><div id='rtable' style='display:none'>"+rtable+"</div>":"")
		+(ndefines?'<h4>#defines <a href="javascript:showhide(\'_defines\');">&gt;&gt;</a></h4><div id="_defines" style="display:none">'+defines_text+'</div>':"")
		//+(pagefname?"<h4>Rename: <a href='javascript:rename()'>&gt;&gt;</a></h4>":"")
	rqth.style.display = "";
	
} // end of reqShow

function rename_ins_pname(id)
{
	var idspl = id.split(".");
	var i=0;
	if(idspl[i]=="app")
		i++;
	if(pagefnames[idspl[i]])
		return id;
	var res_l=idspl.slice(0,i+1).join(".");
	var res_r = idspl.slice(i+1,idspl.length).join(".");
	var res = res_l+ (res_l?".":"")+pagefname+(res_r?".":"")+res_r;
	//window.alert(id+": "+res_l+","+pagefname+","+res_r);
	return res;
}

function getElementText(el)
{
    if ('string' == typeof el.textContent) return el.textContent;
    if ('string' == typeof el.innerText) return el.innerText;
    return el.innerHTML.replace(/<[^>]*>/g,'');
}

function hideShowTemplate()
{
    var document = window.document;
    /* show or hide template */
    showhide('rtmph');
    showhide('template');
    var titleEl = document.getElementById('rtmph');
    var showhidetmp = document.getElementById("show_hide_tmp");
    if(showhidetmp != null)
    {
        if( titleEl.style.display == "none")
        {
            showhidetmp.innerHTML = '<div id="show_hide_tmp"><a href="javascript:hideShowTemplate();">Show Template</a></div>';
        }
        else
        {
            showhidetmp.innerHTML = '<div id="show_hide_tmp"><a href="javascript:hideShowTemplate();">Hide Template</a></div>';
        }
    }
}
